<?php
    /**
     * Created by Leonid "nornik" Sumatokhin.
     *
     * Email: info@bhead.net
     * WWW  : http://bhead.net/
     *
     * Input variables:
     *  - websms_username - login, is required
     *  - websms_password - password, is required
     *  - websms_phone    - recipient number, is required. Example 79191234567
     *  - websms_message  - sms text, is required
     *  - show_resut      - show result, is optionaly
     */

    include(MODX_CORE_PATH . 'components/websms/model/websms.class.php');

    $websms = new Websms();

    $result = '';

    if (!empty($websms_message) and !empty($websms_phone) and !empty($websms_username) and !empty($websms_password)) {
        $websms->set_username($websms_username);
        $websms->set_password($websms_password);
        $websms->set_phones($websms_phone);
        $websms->set_message($websms_message);

        if (isset($parameters)) {
            foreach (explode(',', $parameters) as $param_pair) {
                list($param_key, $param_val) = explode('=', $param_pair);

                $websms->set_parameter($param_key, $param_val);
            }
        }

        if ($websms->send_sms()) {
            $result = $websms->get_send_result();
        } else {
            $result = $websms->get_send_error();
        }

        if (!isset($show_result) or $show_result == false) {
            $result = '';
        }
    }


    return $result;