<?php
    /**
     * Created by Leonid "nornik" Sumatokhin.
     *
     * Email: info@bhead.net
     * WWW  : http://bhead.net/
     *
     */

    class Websms {
        private $_url = 'http://cab.websms.ru/http_in6.asp';
        private $_api_parameters = array();
        private $_dop_parameters = array();
        private $_username;
        private $_password;
        private $_sender;
        private $_phones;
        private $_message;

        private $_tpl = 'chnkSendSmsForm';
        private $_send_result;
        private $_send_error;

        public function get_template() {
            return $this->_tpl;
        }

        public function set_username($username) {
            $this->_username = urlencode($username);
        }

        public function set_password($password) {
            $this->_password = urlencode($password);
        }

        public function set_sender($sender) {
            $this->_sender = $sender;
        }

        public function set_phones($phones) {
            $this->_phones = $phones;
        }

        public function set_message($message) {
            $this->_message = urlencode($message);
        }

        public function set_parameter($param_key, $param_value) {
            $this->_dop_parameters[$param_key] = $param_value;
        }

        public function set_parameters() {
            $parameters     = array();

            $this->_api_parameters = array(
                'Http_username' => $this->_username,
                'Http_password' => $this->_password,
                'Phone_list'    => $this->_phones,
                'Message'       => $this->_message
            );

            foreach ($this->_api_parameters as $param_key => $param_value) {
                $parameters[] = $param_key . '=' . $param_value;
            }

            foreach ($this->_dop_parameters as $param_key => $param_value) {
                $parameters[] = $param_key . '=' . $param_value;
            }

            $parameters['module_cms'] = '';
            $parameters['module_ver'] = '';

            $this->_api_parameters = implode('&', $parameters);
        }

        public function send_sms() {
            $this->set_parameters();

            return $this->_send_sms();
        }

        public function get_send_result() {
            return $this->_send_result;
        }

        public function get_send_error() {
            return $this->_send_error;
        }

        private function _send_sms() {
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $this->_url);
            curl_setopt($ch, CURLOPT_HEADER, false);
            curl_setopt($ch, CURLOPT_TIMEOUT, 10);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $this->_api_parameters);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

            $data = trim(curl_exec($ch));
            curl_close($ch);

            preg_match("/message_id\s*=\s*[0-9]+/i", $data, $retval);
            $message_id = preg_replace("/message_id\s*=\s*/i", "", @strval($retval[0]) );

            if ($message_id > 0) {
                $this->_send_result = $message_id;

                return true;
            } else {
                $this->_send_error = $message_id;

                return false;
            }
        }
    }